> For the complete documentation index, see [llms.txt](https://docs.netmap.dev/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.netmap.dev/product-introduction/architecture.md).

# Architecture

```mermaid
flowchart LR
    Browser[Browser SPA] --> Nginx[nginx]
    Client[API client] --> Nginx
    Device[Syslog sender] --> Syslog[Syslog service]
    Nginx --> Uvicorn[uvicorn Unix socket]
    Uvicorn --> API[FastAPI /api/v1]
    API --> Auth[Auth dependencies]
    Auth --> Services[Services]
    Services --> MainDB[(netmap.db)]
    Syslog --> FirewallDB[(firewall.db)]
    Services --> FirewallDB
    Services --> Workers[Background workers]
    Workers --> MainDB
    Workers --> FirewallDB
```

Verified source:

* App entrypoint: `backend/app/main.py`.
* API router mount: `app.include_router(api_router, prefix="/api/v1")`.
* nginx proxy: `docker/aio-nginx.conf.template`.
* entrypoint process supervision: `docker/aio-entrypoint.sh` and `tini`.
* main DB session: `backend/app/db/session.py`.
* firewall DB session: `backend/app/db/firewall_session.py`.

Background services start during FastAPI startup: syslog, alert monitor, scheduled discovery, IP reservation reminders, scheduled backups, and firewall startup maintenance.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.netmap.dev/product-introduction/architecture.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
